% doVarianceDecomposition1.m

% WARNING: NOT YET READY

clear all; close all; clc

z1  = load('..\SIMULATION\fullModelSimul_results') ;
irf = z1.oo_.irfs ;

hor = [1 5 9 13];
% ------------------------------------------------------------------------
% ---> Decomposition for output growth
% ------------------------------------------------------------------------
y    = [(irf.dY_o_epsz)' (irf.dY_o_epsc)' (irf.dY_o_epsw)' ...
    (irf.dY_o_epsi)' (irf.dY_o_epsp)' (irf.dY_o_epsR)' (irf.dY_o_epss)'];
yz   = cumsum((irf.dY_o_epsz).^2)';
yc   = cumsum((irf.dY_o_epsc).^2)';
yw   = cumsum((irf.dY_o_epsw).^2)';
yi   = cumsum((irf.dY_o_epsi).^2)';
yp   = cumsum((irf.dY_o_epsp).^2)';
yR   = cumsum((irf.dY_o_epsR).^2)';
ys   = cumsum((irf.dY_o_epss).^2)';
ytot = cumsum(sum(y.^2,2));
% ------------------------------------------------------------------------
cy_z = yz./ytot;
cy_c = yc./ytot;
cy_w = yw./ytot;
cy_i = yi./ytot;
cy_p = yp./ytot;
cy_R = yR./ytot;
cy_s = ys./ytot;
% ------------------------------------------------------------------------
Dy = 100*[cy_R(hor) cy_c(hor) cy_i(hor) cy_w(hor) cy_p(hor) cy_z(hor) cy_s(hor)];


% ------------------------------------------------------------------------
% ---> Decomposition for consumption
% ------------------------------------------------------------------------
c    = [(irf.dC_o_epsz)' (irf.dC_o_epsc)' (irf.dC_o_epsw)' ...
    (irf.dC_o_epsi)' (irf.dC_o_epsp)' (irf.dC_o_epsR)' (irf.dC_o_epss)'];
cz   = cumsum((irf.dC_o_epsz).^2)';
cc   = cumsum((irf.dC_o_epsc).^2)';
cw   = cumsum((irf.dC_o_epsw).^2)';
ci   = cumsum((irf.dC_o_epsi).^2)';
cp   = cumsum((irf.dC_o_epsp).^2)';
cR   = cumsum((irf.dC_o_epsR).^2)';
cs   = cumsum((irf.dC_o_epss).^2)';
ctot = cumsum(sum(c.^2,2));
% ------------------------------------------------------------------------
cc_z = cz./ctot;
cc_c = cc./ctot;
cc_w = cw./ctot;
cc_i = ci./ctot;
cc_p = cp./ctot;
cc_R = cR./ctot;
cc_s = cs./ctot;
% ------------------------------------------------------------------------
Dc = 100*[cc_R(hor) cc_c(hor) cc_i(hor) cc_w(hor) cc_p(hor) cc_z(hor) cc_s(hor)];


% ------------------------------------------------------------------------
% ---> Decomposition for investment
% ------------------------------------------------------------------------
i    = [(irf.dI_o_epsz)' (irf.dI_o_epsc)' (irf.dI_o_epsw)' ...
    (irf.dI_o_epsi)' (irf.dI_o_epsp)' (irf.dI_o_epsR)' (irf.dI_o_epss)'];
iz   = cumsum((irf.dI_o_epsz).^2)';
ic   = cumsum((irf.dI_o_epsc).^2)';
iw   = cumsum((irf.dI_o_epsw).^2)';
ii   = cumsum((irf.dI_o_epsi).^2)';
ip   = cumsum((irf.dI_o_epsp).^2)';
iR   = cumsum((irf.dI_o_epsR).^2)';
is   = cumsum((irf.dI_o_epss).^2)';
itot = cumsum(sum(i.^2,2));
% ------------------------------------------------------------------------
ci_z = iz./itot;
ci_c = ic./itot;
ci_w = iw./itot;
ci_i = ii./itot;
ci_p = ip./itot;
ci_R = iR./itot;
ci_s = is./itot;
% ------------------------------------------------------------------------
Di = 100*[ci_R(hor) ci_c(hor) ci_i(hor) ci_w(hor) ci_p(hor) ci_z(hor) ci_s(hor)];

% ------------------------------------------------------------------------
% ---> Decomposition for employment
% ------------------------------------------------------------------------
n    = [(irf.n_IM_epsz)' (irf.n_IM_epsc)' (irf.n_IM_epsw)' ...
    (irf.n_IM_epsi)' (irf.n_IM_epsp)' (irf.n_IM_epsR)' (irf.n_IM_epss)'];
nz   = cumsum((irf.n_IM_epsz).^2)';
nc   = cumsum((irf.n_IM_epsc).^2)';
nw   = cumsum((irf.n_IM_epsw).^2)';
ni   = cumsum((irf.n_IM_epsi).^2)';
np   = cumsum((irf.n_IM_epsp).^2)';
nR   = cumsum((irf.n_IM_epsR).^2)';
ns   = cumsum((irf.n_IM_epss).^2)';
ntot = cumsum(sum(n.^2,2));
% ------------------------------------------------------------------------
cn_z = nz./ntot;
cn_c = nc./ntot;
cn_w = nw./ntot;
cn_i = ni./ntot;
cn_p = np./ntot;
cn_R = nR./ntot;
cn_s = ns./ntot;
% ------------------------------------------------------------------------
Dn = 100*[cn_R(hor) cn_c(hor) cn_i(hor) cn_w(hor) cn_p(hor) cn_z(hor) cn_s(hor)];




fid = fopen('..\..\TEXFILES\TABLES\varianceDecompositionTable1.tex','w+');
fprintf(fid,'%s \n','\begin{table}[tbp]');
fprintf(fid,'%s \n','\centering');
fprintf(fid,'%s \n','\caption{Variance Decomposition}\label{tab:vardec1}');
fprintf(fid,'%s \n','\newcolumntype{Y}{>{\centering\arraybackslash}X}');
fprintf(fid,'%s \n','\begin{tabularx}{\textwidth}{lYYYYYYY}');
fprintf(fid,'%s \n','\hline \hline');
fprintf(fid,'%-15s & %s \\\\ \n',' ','\multicolumn{7}{c}{Output Growth\rhi}');
fprintf(fid,'%-15s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s \\\\ \n',...
    'Quarter\rlo','$\epsilon_R$','$\epsilon_c$','$\epsilon_i$',...
    '$\epsilon_w$','$\epsilon_p$','$\epsilon_z$','$\epsilon_s$');
fprintf(fid,'%s \n','\cline{2-8}');
for iter = 1:size(Dy,1);
    if iter==1
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1),' \rhi'],Dy(iter,1),Dy(iter,2),Dy(iter,3),Dy(iter,4),Dy(iter,5),Dy(iter,6),Dy(iter,7));
    elseif iter==size(Dy,1)
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1)],Dy(iter,1),Dy(iter,2),Dy(iter,3),Dy(iter,4),Dy(iter,5),Dy(iter,6),Dy(iter,7));
    else
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            num2str(hor(iter)-1),Dy(iter,1),Dy(iter,2),Dy(iter,3),Dy(iter,4),Dy(iter,5),Dy(iter,6),Dy(iter,7));
    end
end
fprintf(fid,'%-15s & %s \\\\ \n',' ','\multicolumn{7}{c}{Consumption Growth}');
fprintf(fid,'%-15s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s \\\\ \n',...
    'Quarter\rlo','$\epsilon_R$','$\epsilon_c$','$\epsilon_i$',...
    '$\epsilon_w$','$\epsilon_p$','$\epsilon_z$','$\epsilon_s$');
fprintf(fid,'%s \n','\cline{2-8}');
for iter = 1:size(Dc,1);
    if iter==1
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1),' \rhi'],Dc(iter,1),Dc(iter,2),Dc(iter,3),Dc(iter,4),Dc(iter,5),Dc(iter,6),Dc(iter,7));
    elseif iter==size(Dc,1)
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1)],Dc(iter,1),Dc(iter,2),Dc(iter,3),Dc(iter,4),Dc(iter,5),Dc(iter,6),Dc(iter,7));
    else
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            num2str(hor(iter)-1),Dc(iter,1),Dc(iter,2),Dc(iter,3),Dc(iter,4),Dc(iter,5),Dc(iter,6),Dc(iter,7));
    end
end
fprintf(fid,'%-15s & %s \\\\ \n',' ','\multicolumn{7}{c}{Investment Growth}');
fprintf(fid,'%-15s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s \\\\ \n',...
    'Quarter\rlo','$\epsilon_R$','$\epsilon_c$','$\epsilon_i$',...
    '$\epsilon_w$','$\epsilon_p$','$\epsilon_z$','$\epsilon_s$');
fprintf(fid,'%s \n','\cline{2-8}');
for iter = 1:size(Di,1);
    if iter==1
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1),' \rhi'],Di(iter,1),Di(iter,2),Di(iter,3),Di(iter,4),Di(iter,5),Di(iter,6),Di(iter,7));
    elseif iter==size(Di,1)
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1),],Di(iter,1),Di(iter,2),Di(iter,3),Di(iter,4),Di(iter,5),Di(iter,6),Di(iter,7));
    else
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            num2str(hor(iter)-1),Di(iter,1),Di(iter,2),Di(iter,3),Di(iter,4),Di(iter,5),Di(iter,6),Di(iter,7));
    end
end
fprintf(fid,'%-15s & %s \\\\ \n',' ','\multicolumn{7}{c}{Employment}');
fprintf(fid,'%-15s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s & %-17s \\\\ \n',...
    'Quarter\rlo','$\epsilon_R$','$\epsilon_c$','$\epsilon_i$',...
    '$\epsilon_w$','$\epsilon_p$','$\epsilon_z$','$\epsilon_s$');
fprintf(fid,'%s \n','\cline{2-8}');
for iter = 1:size(Dn,1);
    if iter==1
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1),' \rhi'],Dn(iter,1),Dn(iter,2),Dn(iter,3),Dn(iter,4),Dn(iter,5),Dn(iter,6),Dn(iter,7));
    elseif iter==size(Dn,1)
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            [num2str(hor(iter)-1),' \rlo'],Dn(iter,1),Dn(iter,2),Dn(iter,3),Dn(iter,4),Dn(iter,5),Dn(iter,6),Dn(iter,7));
    else
        fprintf(fid,'%-15s & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f & %17.2f \\\\ \n',...
            num2str(hor(iter)-1),Dn(iter,1),Dn(iter,2),Dn(iter,3),Dn(iter,4),Dn(iter,5),Dn(iter,6),Dn(iter,7));
    end
end
fprintf(fid,'%s \n','\hline \hline');
fprintf(fid,'%s \n','\end{tabularx}');
fprintf(fid,'%s \n','\end{table}');
fclose(fid);
