// --------------------------------------------------------------------
//  V A R I A B L E  D E C L A R A T I O N
// --------------------------------------------------------------------
var
// --------------------------------------------------------------------
// model variables
// --------------------------------------------------------------------
r R MF MW lamF lame lameu cF ce ceu cuu aF ae Ae Je
lambda m v s f n neu nuu rho
k i u y ym rk pk w q tau
pm Kp Fp pstar Delta pi pia c c40 c60 s60 cndreduc1 cndreduc2 lamuu cndw
lc li ly lc60 lc40 lw linv Ra lcHtM

// --------------------------------------------------------------------
// shocks
// --------------------------------------------------------------------
@#for name in [ "c", "w", "i", "p", "R", "z", "s", "a", "me", "m", "t" ]
    fi@{name}
@#endfor
// --------------------------------------------------------------------
// observables
// --------------------------------------------------------------------
R_o dC40_o dC60_o sh60_o dC_o dI_o dY_o df_o ds_o dP_o dW_o s_o f_o

;


// --------------------------------------------------------------------
//  E X O G E N O U S  V A R I A B L E  D E C L A R A T I O N
// --------------------------------------------------------------------
varexo
@#for name in [ "c", "w", "i", "p", "R", "z", "s", "a", "me", "m", "t" ]
    eps@{name} $\epsilon_{@{name}}$
@#endfor

;

// --------------------------------------------------------------------
//  P A R A M E T E R S  D E C L A R A T I O N
// --------------------------------------------------------------------
parameters
// --------------------------------------------------------------------
// structural parameters
// --------------------------------------------------------------------
sig $\sigma$ delta $\delta$ theta $\theta$ chi $\chi$ hF $h$ Omega $\Omega$
kv_y ceu_ce
lsh reprat
nu $\nu_u$ ni $\nu_i$ alpha $\alpha$ gammap $\gamma_p$ 
gammaw $\gamma_w$ psin $\psi_n$
rhoTR $\rho$ api $a_\pi$ ay $a_y$
cstP cstW cstY cstR cstf csts cstdf cstds csts60 lambdaHP
// --------------------------------------------------------------------
// shocks
// --------------------------------------------------------------------
@#for name in [ "c", "w", "i", "p", "R", "z", "s", "a", "me", "m", "t" ]
    rho@{name} $\rho_{@{name}}$ sig@{name} $\sigma_{@{name}}$
@#endfor
;

