function xsp = ma(x,lag) 
% xsp = ma4(x) ; 
%
% Calculates the one-sided 4-period moving average

[T,N] = size(x);

w = ones(lag,1) ; 
s = w/sum(w) ;
xpad = [repmat(x(1,:),lag,1);x] ;
xsp = zeros(T,N) ;
i = 1;
while i <= T
    xsp(i,:) = s'*xpad(i:i+lag-1,:) ; 
    i = i+1;
end
