function [] = printParamInFile(M_,oo_,mode)
% PRINTPARAM.M : 
%
% print the parameters  in the file
% labeled [MOD FILE NAME]EstimatedParameters.M

fname = M_.fname;
pnam  = fieldnames(oo_.posterior_mode.parameters) ; %estim_params_.param_names ;
if mode
    pval  = oo_.posterior_mode.parameters;
else
    pval  = oo_.posterior_mean.parameters;
end
zz    = char(pnam);

fid = fopen([fname,'EstimParameters.m'],'w+');
for i = 1:size(pnam,1)
    fprintf(fid,'%s =  \t %4.25f; \n',zz(i,:),eval(['pval.',pnam{i}]));
end
fclose(fid);